package de.laliluna.howto.application;

import javax.faces.context.FacesContextFactory;
import javax.faces.context.FacesContext;
import javax.faces.lifecycle.Lifecycle;
import javax.faces.FacesException;

/**
 * Factory to create our custom Facescontext
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 23.10.2009
 */
public class CustomFacesContextFactory extends FacesContextFactory{
	private FacesContextFactory parent;

	public CustomFacesContextFactory(FacesContextFactory parent) {
		this.parent = parent;
	}

	public FacesContext getFacesContext(Object context, Object request, Object response, Lifecycle lifecycle) throws FacesException {
		FacesContext parentContext = parent.getFacesContext(context, request, response, lifecycle);

		return new CustomFacesContext(parentContext);
	}
}
