
package de.laliluna.howto.application;

import java.util.ArrayList;
import java.util.List;

public class UrlAnalyser {

	public static final String XHTML_SUFFIX = ".xhtml";

	/**
	 * Analyse a URL like /aDir/books/foo and returns a list of possible xhtml files.
	 * /aDir/books/foo.xhtml
	 * /aDir/books.xhtml
	 * Return null if the URL doesn't look like a Rest URL = it has a . in the last element
	 * like /foo.xhtml or /bazz.css
	 * @return
	 */
	public List<String> analyse(String path){
		int pos = path.lastIndexOf('/');
		if(pos == 0 && path.length()==1)
			return null;
		// the ending should not contain a dot like /styles.css or /foo.xhtml
		if(path.indexOf('.', pos) != -1)
			return null;

		List<String> elements = new ArrayList<String>();
		if(path.endsWith("/"))
			elements.add(path.substring(0, path.length()-1)+XHTML_SUFFIX);
		else{
			elements.add(path+XHTML_SUFFIX);
			if(pos > 0)
				elements.add(path.substring(0,pos)+XHTML_SUFFIX);
		}
		return elements;
	}
}
