package de.laliluna.howto.beans;

import org.apache.log4j.Logger;

import javax.faces.bean.ManagedBean;
import javax.faces.event.PhaseListener;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.ActionEvent;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 29.09.2009
 */
@ManagedBean
public class Dummy implements PhaseListener {
	private final Logger logger = Logger
			.getLogger(Dummy.class.getName());

	public boolean isRenderFoo() {
		return true;
	}

	public boolean isRenderNotFoo() {
		return false;
	}

	public String getHello() {
		return "hello Bar";
	}


	public void afterPhase(PhaseEvent event) {
		logger.info("After phase " + event.getPhaseId());
		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
		for (StackTraceElement element : stackTraceElements) {
			System.out.println(element);
		}
	}

	public void beforePhase(PhaseEvent event) {
		logger.info("Before phase " + event.getPhaseId());
	}

	public PhaseId getPhaseId() {
		return PhaseId.ANY_PHASE;
	}
}
