package de.laliluna.howto.beans;

import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import java.util.Map;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 21.10.2009
 */
@ManagedBean
public class ErrorBean {
	private static final String BR = "\n";

	public String getStackTrace() {
		FacesContext context = FacesContext.getCurrentInstance();
		Map<String, Object> map = context.getExternalContext().getRequestMap();
		Throwable throwable = (Throwable) map.get("javax.servlet.error.exception");
		StringBuilder builder = new StringBuilder();
		builder.append(throwable.getMessage()).append(BR);
		for (StackTraceElement element : throwable.getStackTrace()) {
			builder.append(element).append(BR);
		}
		return builder.toString();
	}

	private boolean fireException = false;

	public String getFire() {
		if (fireException)
			throw new IllegalArgumentException("This method was called with really bad arguments.");
		return "";
	}

	public void setFire(boolean fireException) {
		// do nothing
	}

	public void createException() {
		if(true)
		throw new IllegalArgumentException("This method was called with really bad arguments.");
		this.fireException = true;
	}
}
