package de.laliluna.howto.beans;

import org.apache.log4j.Logger;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.ManagedProperty;
import javax.faces.context.FacesContext;
import javax.annotation.PreDestroy;
import javax.annotation.PostConstruct;
import javax.servlet.http.HttpSession;
import java.util.Enumeration;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 08.10.2009
 */
@ManagedBean
@RequestScoped
public class RequestScopeSample {
	private static Logger logger = Logger.getLogger(ViewScopeSample.class.getName());

	private int counter;

	public int getCounter() {
		return counter++;
	}

	@ManagedProperty("foo is foo")
	private String foo;

	@ManagedProperty("#{viewScopeSample}")
	private ViewScopeSample viewScopeSample;

	public void setViewScopeSample(ViewScopeSample viewScopeSample) {
		this.viewScopeSample = viewScopeSample;
	}

	public String getFoo() {
		return foo;
	}

	public void setFoo(String foo) {
		this.foo = foo;
	}

	@PostConstruct
	public void postCreate(){
		logger.info("RequestScopeSample bean is created");
	}

	@PreDestroy
	public void preDestroy(){
		logger.info("RequestScopeSample bean is destroyed");

	}
}
