package de.laliluna.howto.beans;

import de.laliluna.howto.services.security.JAASHelper;
import de.laliluna.howto.services.security.JAASPrincipal;
import de.laliluna.howto.services.security.JAASRolePrincipal;

import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.servlet.http.HttpServletRequest;
import javax.security.auth.Subject;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.security.Principal;
import java.util.Map;
import java.util.Set;

import com.sun.security.auth.UserPrincipal;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 16.10.2009
 */
@ManagedBean
public class Security {
	final Logger logger = LoggerFactory.getLogger(Security.class);
	private String username;
	private String password;

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String login() {
		JAASHelper helper = new JAASHelper();

		if (helper.authenticate(username, password)){
			FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("de.laliluna.jaas.subject",helper.getSubject());
			return "loginSuccess?faces-redirect=true";
		}
		else {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Login failed"));
			return null;
		}
	}

	public Principal getPrincipal(){
		Subject subject = (Subject) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("de.laliluna.jaas.subject");
		if(subject != null){
			// there should be only one
			Set<JAASPrincipal> userPrincipals = subject.getPrincipals(JAASPrincipal.class);
			if(userPrincipals.size()!= 0)
				return userPrincipals.iterator().next();
		}
		return null;
	}

	public boolean isUserInRole(String role){
		Subject subject = (Subject) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("de.laliluna.jaas.subject");
		Set<JAASRolePrincipal> jaasRolePrincipalSet = subject.getPrincipals(JAASRolePrincipal.class);
		for (JAASRolePrincipal aRole : jaasRolePrincipalSet) {
			if(aRole.equals(role))
				return true;
		}
		return false;
	}
	
}
