package de.laliluna.howto.components;

import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;
import javax.faces.convert.FacesConverter;
import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.application.FacesMessage;
import java.util.Locale;
import java.text.MessageFormat;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 21.10.2009
 */
@FacesConverter(forClass = Locale.class)
public class LocaleConverter implements Converter {
	public Object getAsObject(FacesContext context, UIComponent uiComponent, String value) {
		if (value == null)
			return null;
		else {
			/** simplified approach. A better approach can be looked up in the source of {@link com.sun.faces.application.view.MultiViewHandler.calculateLocale} */
			if ("en".equals(value))
				return Locale.ENGLISH;
			else if ("de".equals(value))
				return Locale.GERMAN;
			else
				throw new ConverterException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Unsupported Locale", null));
		}
	}

	public String getAsString(FacesContext context, UIComponent uiComponent, Object value) {
		// We are friendly and return at least an empty String
		String stringValue = "";
		if (value != null) {
			// Default components check if the value is a String and return it as it is
			if (value instanceof String)
				stringValue = (String) value;
			else if (value instanceof Locale)
				stringValue = ((Locale) value).getLanguage();
		}
		return stringValue;
	}
}
