package de.laliluna.examples.model;

import java.util.Set;
import java.util.HashSet;

/**
 * Mar 10, 2009
 *
 * @author Sebastian Hennebrueder
 */

public class User {
	private String name;

	private Set<Role> roles = new HashSet<Role>();

	public User() {
	}

	public User(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public User addRole(Role role){
		roles.add(role);
		return this;
	}

	public User removeRole(Role role){
		roles.remove(role);
		return this;
	}

	public Set<Role> getRoles() {
		return roles;
	}

	public void setRoles(Set<Role> roles) {
		this.roles = roles;
	}

	public boolean containsRole(String role) {
		for (Role r : roles) {
			if (role.equals(r.getName()))
				return true;
		}
		return false;
	}
}
